package java.net;

public final class DatagramPacket {
   byte[] buf;
   int length;
   InetAddress address;
   int port;

   public DatagramPacket(byte[] var1, int var2) {
      if (var2 > var1.length) {
         throw new IllegalArgumentException("illegal length");
      } else {
         this.buf = var1;
         this.length = var2;
         this.address = null;
         this.port = -1;
      }
   }

   public DatagramPacket(byte[] var1, int var2, InetAddress var3, int var4) {
      if (var2 > var1.length) {
         throw new IllegalArgumentException("illegal length");
      } else if (var4 >= 0 && var4 <= 65535) {
         this.buf = var1;
         this.length = var2;
         this.address = var3;
         this.port = var4;
      } else {
         throw new IllegalArgumentException("Port out of range:" + var4);
      }
   }

   public synchronized InetAddress getAddress() {
      return this.address;
   }

   public synchronized int getPort() {
      return this.port;
   }

   public synchronized byte[] getData() {
      return this.buf;
   }

   public synchronized int getLength() {
      return this.length;
   }

   public synchronized void setAddress(InetAddress var1) {
      this.address = var1;
   }

   public synchronized void setPort(int var1) {
      if (var1 >= 0 && var1 <= 65535) {
         this.port = var1;
      } else {
         throw new IllegalArgumentException("Port out of range:" + var1);
      }
   }

   public synchronized void setData(byte[] var1) {
      this.buf = var1;
   }

   public synchronized void setLength(int var1) {
      if (var1 > this.buf.length) {
         throw new IllegalArgumentException("illegal length");
      } else {
         this.length = var1;
      }
   }
}
