package java.net;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public abstract class SocketImpl implements SocketOptions {
   // $FF: renamed from: fd java.io.FileDescriptor
   protected FileDescriptor field_0;
   protected InetAddress address;
   protected int port;
   protected int localport;

   protected abstract void create(boolean var1) throws IOException;

   protected abstract void connect(String var1, int var2) throws IOException;

   protected abstract void connect(InetAddress var1, int var2) throws IOException;

   protected abstract void bind(InetAddress var1, int var2) throws IOException;

   protected abstract void listen(int var1) throws IOException;

   protected abstract void accept(SocketImpl var1) throws IOException;

   protected abstract InputStream getInputStream() throws IOException;

   protected abstract OutputStream getOutputStream() throws IOException;

   protected abstract int available() throws IOException;

   protected abstract void close() throws IOException;

   protected FileDescriptor getFileDescriptor() {
      return this.field_0;
   }

   protected InetAddress getInetAddress() {
      return this.address;
   }

   protected int getPort() {
      return this.port;
   }

   protected int getLocalPort() {
      return this.localport;
   }

   public String toString() {
      return "Socket[addr=" + this.getInetAddress() + ",port=" + this.getPort() + ",localport=" + this.getLocalPort() + "]";
   }

   public abstract void setOption(int var1, Object var2) throws SocketException;

   public abstract Object getOption(int var1) throws SocketException;
}
